{$apptype console}
{$O-,Q+}

uses
        SysUtils, Math;

const
        depth = 665;

type
        tproc = procedure(len : integer);

function random2(hi : integer) : integer;
begin
    result := random(random(hi) + 1);
end;

function randomch : char;
var
        i : integer;

begin
        i := random(62);
        case i of
                0..9: result := chr(ord('0') + i);
                10..35 : result := chr(ord('a') + i - 10);
                36..61 : result := chr(ord('A') + i - 36);
        end;
end;

procedure writeident(len : integer);
var
        i : integer;
begin
    if len < 1 then
        runerror(6);
        for i := 1 to len do
                write(randomch);
end;

procedure writews(nws : integer);
var
        i : integer;
begin
    if nws < 0 then
        runerror(7);
        i := 0;
        while i < nws do begin
                case random(3) of
                        0 : write(' ');
                        1 : begin
                                if i + 1 < nws then begin
                                        write(#13#10);
                                        inc(i);
                                end else
                                        continue;
                        end;
                        2 : write(#9);
                end;
                inc(i);
        end;
end;

procedure writeblock(len : integer); forward;

procedure distribute(p : tproc; len, minlen : integer; sep : string);
var
        i, n, cur, ave : integer;

begin
    if len < minlen then
        runerror(4);

    if len < 2 * (minlen + length(sep)) then
        n := 1
    else
        n := random2(len div (minlen + length(sep)) - 1) + 1;

        ave := len div n;
        for i := 1 to n - 1 do begin
                cur := min(
                        len - (minlen + length(sep)) * (n - i),
                        (ave - 1) div 2 + random(ave) + minlen);
                p(cur);
                write(sep);
                dec(len, cur + length(sep));
        end;
        p(len);
end;

procedure writeexpression(len : integer);
var
        a, b, c, x, y, z : integer;

begin
        if len < 1 then
                runerror(3);

    x := random2(len div 5);
    a := random(len div 5) + 1;
    b := random(len div 3) + 1;
    y := random2(len div 5);
    z := random2(len div 5);
    c := len - a - b - x - y - z;

    if b < 3 then begin
        inc(c, b);
        b := 0;
    end;

    if c < 4 then begin
        inc(a, c);
        c := 0;
        end;

    if (a < 0) or (b < 0) or (c < 0) then
        runerror(5);

    writews(x);
    writeident(a);
    if b > 0 then begin
        write('(');
        distribute(writeexpression, b - 2, 1, ',');
        write(')');
    end;

    writews(z);
        if c > 0 then
                writeblock(c);
    writews(y);
end;

procedure writestatement(len : integer);
begin
        if len < 2 then
                runerror(1);

        writeexpression(len - 1);
        write(';');
end;

procedure writeblock(len : integer);
var
    a, x, y, z : integer;

begin
        if len < 4 then
                runerror(2);

    x := random2(len div 5);
    y := random2(len div 5);
    z := random2(len div 5);

    a := len - x - y - z;

    if a < 4 then begin
        a := len;
        x := 0;
        y := 0;
        z := 0;
    end;

    writews(x);
        write('{');
        distribute(writestatement, a - 2, 2, '');
    writews(z);
        write('}');
    writews(y);
end;

procedure writeprogram(len : integer);
begin
        writeblock(len);
end;

begin
  assign(output, 'code.in'); rewrite(output);
        randseed := strtoint(paramstr(2));
        writeprogram(strtoint(paramstr(1)));
  close(output);
end.
